;       Last change    August 1993
(in-package equal)   


(defun enter-not-equal (net a1 a2 &aux mems1 mems2
			      (a1name (non-equal-set-name a1))
			      (a2name (non-equal-set-name a2))
			      (s1 (writeable-copy net (getset net a1name)))
			      (s2 (writeable-copy net (getset net a2name))))
  (change-field 'episet-properties s1 (append (episet-properties s1) 
					      (list 'non-equal)))
  (change-field 'episet-properties s2 (append (episet-properties s2) 
					      (list 'non-equal)))
  (setq mems1 (episet-contents s1))
  (setq mems2 (episet-contents s2))
  (setq mems1 (union mems1 (list a2 '+)))
  (setq mems2 (union mems2 (list a1 '+)))
  ; update cardinality and members
  (update-card net s1 mems1 nil)
  (update-card net s2 mems2 nil)
  )

; enter enters the literal lit 

(defun enter (netname lit negp pred arglist &aux
		      (net (determine-net netname))
		      (a1 (car arglist))
		      (a2 (cadr arglist))
		      (a3 (caddr arglist))
		      )
  (declare (ignore lit))
  (when (and (not (non-constant-arg arglist))
	     (if negp 
		 (not (and (equal (find-sort a1) 'set) 
			   (equal (find-sort a2) 'set))) 
		 t)
	     (null a3))
	(when (traced-p 'epilog::equality-entry)
	      (print-line "    Equality Specialist: Entering " 
			  (if negp "NOT " "") (print-info a1) " " 
			(print-info pred) " " (if a2 (print-info a2) ""))
	      (if (not (equal (episet-subnet-identifier net) '/))   
		  (print-it "    into subnet " (episet-subnet-identifier net)))
	      )
	(cond (negp
	       (enter-not-equal net a1 a2))
	      (t (enter-equivalence net a1 a2 nil)))
	)
  )
