;       Last change    August 1993
(in-package user)
(eval-when (compile load eval)   
(provide 'equality-specialist)
(require 'epilib "epilog:epilib;epilib")
(require 'spec "epilog:spec;spec")
(require 'set-equal 
  "epilog:set-equal;set-equal")
(defpackage equality-specialist (:nicknames equality equal) 
  (:use lisp user spec lib epilib set-equal)
  (:export
	  ;; Functions for the specialist interface

	  enter evaluate incompatible-lits compatible-lits

	  ))
(unless (find-package 'equality) (make-package 'equality)))
(in-package equal)   


(traceable 'epilog::equality-entry "Traces input of equality information") 
(traceable 'epilog::equality-eval "Traces evaluation of equality information") 
(traceable 'epilog::equality-function-eval "Traces evaluation of equality functions") 
(traceable 'epilog::equality-test "Traces comparison of equality literals") 
(traceable 'epilog::equality-all "Traces everything about equality"
           '(epilog::equality-entry epilog::equality-eval epilog::equality-test
	     epilog::equality-function-eval)
	   )
(traceable 'epilog::equality-min "Traces interesting things about equality"
           '(epilog::equality-entry epilog::equality-eval epilog::equality-test
	     epilog::equality-function-eval)
	   )

(load "epilog:equal;functions")
(load "epilog:equal;eval")
(load "epilog:equal;enter")
(load "epilog:equal;print")
(load "epilog:equal;compare")
