;       Last change    August 1993
(in-package part)


(set-display-function 'epilog::part-info 'part-info 
  "Displays information about parts")

(defun print-s-info (item)
  (if (null item) "unknown" item))

; print part contents

(defun print-part (brief key node)
  (declare (ignore brief))
  (unless (null node)
	  (print-line key #\tab "Name: " (part-name node) )
	  (when (part-collection node) (print-it #\tab "collection"))
	  (when (part-owning-entity node)
		(print-it #\tab "Owned by: " (part-owning-entity node)))
	  (when (part-types node)
		(print-line #\tab (if (part-collection node)
				      "Member Types: " "Types: " )
			    (mapcar 'print-info (part-types node)))) 
	  (when (part-super-parts node)
		(print-line #\tab "Super parts: " (part-super-parts node))) 
	  (when (part-parts node)
		(print-line #\tab "Sub parts: " (part-parts node) ))
	  )
  nil)

(defun print-parts (brief st)
  (maphash #'(lambda (key node) (print-part brief key node)) st)
)

(defun print-net (context &aux
			  (usec context))
  (if (null context)
      (setq usec '/))
  (let ((context-array (retrieve-specialist-info *environment*
						 'part)))
    (if (null context-array)
	nil
      (gethash usec context-array))))

(defun part-info (brief &rest args &aux 
		       (pn (car args))
		       (context (cadr args))
		       (net (print-net context)))
  (when (not (null net))
	(if (or (null pn)
		(equal pn 'epilog::all))
	    (let ()
	         (print-line "Parts for Context" #\tab 
			    (if (null context) '/ context))
                 (print-parts brief (part-subnet-parts net))
		 )
	    (print-part brief pn (findpart net pn))
	    ))
  )

