;       Last change    August 1993
(in-package response)

(defvar *success-combine* nil)
(defvar *again* nil)

(defun conjunct-frags (&rest lists &aux
			     change plist nplist tryagain nm res)
  (if (< (list-length lists) 2) (return-from conjunct-frags lists))
  (setq lists (remove-if #'(lambda (a) (and (member (find-sort (fragment-name a)) '(pred operator quantifier meta-entity)) (equal (fragment-fragtype a) 'NP)
					    (null (fragment-noun a)))) lists))
  (when (traced-p 'combine)
	(print-line "  Response: need to combine conjunctively: ")
	(mapcar #'(lambda (f) (print-frag f 2)) lists) )
  ; for each item in list, try to combine with all parts coming after it
  (setq plist lists)
  (do ((l (car plist) (car plist)))
      ((null l))
      (setq plist (cdr plist))
      (setq nplist plist)
      (do ((l2 (car nplist) (car nplist)))
	  ((null l2))
	  (setq nplist (cdr nplist))
	  ; try to combine these
	  ; if successful, replace on list
	  (setq *success-combine* nil)
	  (if (setq nm (fragment-name l))
	      (setq res (conjunct2 nm l l2)))
	  (unless *success-combine*
		  (if (setq nm (fragment-name l2))
		      (setq res (conjunct2 nm l2 l))))
	  (unless *success-combine*
		  (if (and (null nm) (null (fragment-name l2))
			   (equal (fragment-fragtype l) 'S)
			   (equal (fragment-fragtype l2) 'S))
		      (setq res (conjunct-same-type nm l l2 'S 'S))))

	  (when *success-combine*
		(if (null res) (print-line "why is res nil?"))
		(when (traced-p 'combine)
		      (print-line "  Response: combined " l " and " l2
				  " into ")
		      (print-frag res 2)
		      )
		(setq change t)
		 (setq lists (remove l lists :test 'equal))
		 (setq lists (remove l2 lists :test 'equal))
		 (setq lists (append (list res) lists))
		 (setq plist (remove l plist :test 'equal))
		 (setq plist (remove l2 plist :test 'equal))
		 (setq plist (append plist (list res)))
		 (return))
	  ) )
	  
  (setq lists (remove-if 'null lists))
  (unless (or *conditional* *again* (= (list-length lists) 1))
	  (setq lists (mapcar #'(lambda (l)
		(if (and (equal (fragment-fragtype l) 'S)
			 (null (fragment-name l))
			 (null (fragment-advp l))
			 (null (fragment-advs l))
			 (fragment-name (fragment-NP l))
			 (not (equal (fragment-name (fragment-NP l)) 
				     'removed))
			 )
		    (let (l3) 
			   (setq l3 (VP-into-RELC l) )
			   (if (null l3) (setq l3 l))
			   (if (not (equal l l3)) (setq tryagain t))
			   l3)
		     l)) lists)))
  (if tryagain 
      (let (nres)
	   (setq *again* t)
	   (setq nres (apply 'conjunct-frags lists))
	   (setq *again* nil)
	   nres)
      (if change lists nil))
  )
; if p1 and p2 have the same subject, is p1 a super part for p2?
(defun super-part (frag1 frag2 &aux 
			 (p1 (getp frag1 'frag-type))
			 (p2 (getp frag2 'frag-type)))
  (case p1
	(NP (member p2 '(AP PP))) ;S
	((AP PP ADVP) nil)
	(S (member p2 '(ADVP)))
	)
  )

(defun conjunct2 (name1 frag1 frag2 &aux slist newf 
			(type1 (getp frag1 'frag-type))
			(type2 (getp frag2 'frag-type)))
  ;try to find name1 in frag2, replace with frag1
  (cond ((null frag2) nil)

	((equal (fragment-name frag2) name1) 
	 (conjunct-same-name name1 frag1 frag2 type1 type2))

	((and (fragment-negated frag1) (fragment-negated frag2)
	      (equal (fragment-fragtype frag1) (fragment-fragtype frag2)))
	 nil)

	(t  ;look for name1 within frag2, try to add frag1 at lower level
	 (setq slist (symbol-plist frag2))
	 (do ((prop (car slist) (car slist))
	      (value (cadr slist) (cadr slist)))
	     ((null prop))
	     (setq slist (cddr slist))
	     (cond ((member prop *fragment-types*)
		    (setq newf (conjunct2 name1 frag1 value))
		    (when *success-combine* 
			  (setp frag2 prop newf)
			  (setp newf 'head frag2)
			  (return-from conjunct2 frag2)) )
		   ((member prop *fragment-groups*)
		    (dolist (p value)
			    (setq newf (conjunct2 name1 frag1 p))
			    (when *success-combine* 
				  (setp newf 'head frag2)
				  (setp frag2 prop
					(substitute newf p value :test 'equal))
				  (return-from conjunct2 frag2))
			    ) )
		   )) )
	)
  )

(defun conjunct-same-type (name1 frag1 frag2 type1 type2 &aux slist np np2
				 vp vp2 newvp namenp)
  (cond ((member type1 '(AP PP RelC))
	 (setq *success-combine* t)
	 (let* ((head (fragment-head frag2))
		(new (make-conj nil 'and (list frag1 frag2) name1)))
	       (setp new 'head head)
	       new))
	((and (equal type1 'S)
	      (equal (fragment-tense frag1) (fragment-tense frag2))
	      (equal (fragment-mood frag1) (fragment-mood frag2))
	      (equal (fragment-aspect frag1) (fragment-aspect frag2))
	      (equal (fragment-negated frag1) (fragment-negated frag2))
	      (setq np (fragment-NP frag1))
	      (setq np2 (fragment-NP frag2))
	      (setq vp (fragment-VP frag1))
	      (setq vp2 (fragment-VP frag2))
	      (not (or (fragment-advp frag1) (fragment-advp frag2)
		       (fragment-advs frag1) (fragment-advs frag2)))
	      (equal (setq namenp (fragment-name np)) (fragment-name np2))
	      (equal (fragment-tense vp) (fragment-tense vp2))
	      (equal (fragment-mood vp) (fragment-mood vp2))
	      (equal (fragment-aspect vp) (fragment-aspect vp2))
	      (equal (fragment-negated vp) (fragment-negated vp2))
	      (not (and (noun-info np) (noun-info np2)))
	      )
	 (setp vp 'name namenp)
	 (setp vp2 'name namenp)
	 (setq newvp (make-conj nil 'and (list vp vp2) namenp))
	 (setq *success-combine* t)
	 (cond ((noun-info np)
		(setp newvp 'head frag1)
		(setp frag1 'VP newvp)
		frag1)
	       (t (setp newvp 'head frag2)
		  (setp frag2 'VP newvp)
		  frag2))
	 )
	 ; combine the VP's into a VPand
	((not-combinable frag1 frag2) 
	 (if (equal type1 'NP) 
	     (if (fragment-negated frag1)
		 frag2
		 (try-relc-combine frag1 frag2) )
	     frag2))
	(t (setq *success-combine* t)
	   (setq slist (symbol-plist frag1))
	   (do ((prop (car slist) (car slist))
		(value (cadr slist) (cadr slist)))
	       ((null prop))
	       (setq slist (cddr slist))
	       (conjunct-prop frag2 prop value))
	   ; if frag1 is on entity list, replace with frag2
	   (unless (and (equal type2 'S) (not (fragment-VP frag1))
			(not (fragment-VP frag2)))
		   (update-entity-info (fragment-name frag1) frag2 frag1)
		   )
	   frag2)
	)
  )

(defun conjunct-same-name (name1 frag1 frag2 type1 type2 &aux np s)
  (cond ((equal type2 type1) 
	 (conjunct-same-type name1 frag1 frag2 type1 type2))
	((or (and (equal type1 'NP) (equal type2 'S)
		  (setq np frag1) (setq s frag2))
	     (and (equal type2 'NP) (equal type1 'S)
		  (setq np frag2) (setq s frag1) ))
	 (cond ((and (fragment-vp s)
		     (or (fragment-noun np) (fragment-AP np) (fragment-PP np) ))
		(setq *success-combine* t)
		(if (member (fragment-noun np) '(event episode propos fact))
		    (return-from conjunct-same-name s))
		(setq s (coerce-to 'NP s))
		(make-frag 'S (cons 'NP s) (cons 'VP (make-into-VP np))))
	       ((or (and (fragment-quantifier np) (null (noun-info np)))
		    (equal (getp (fragment-noun np) 'sort) (fragment-noun np)))
		(setq *success-combine* t)
		(if (fragment-aspect np) (setp s 'aspect (fragment-aspect np)))
		s) 
	       ))
	((not-combinable frag1 frag2) frag2)
	(t (setq *success-combine* t)
	   (if (super-part frag1 frag2)
	       (conjunct-prop frag1 (fragment-fragtype frag2) frag2)
	       (if (super-part frag2 frag1)
		   (conjunct-prop frag2 (fragment-fragtype frag1) frag1)
		   ; otherwise need header typea
		   (let ((typ (highest-type (list (fragment-fragtype frag1) 
						  (fragment-fragtype frag2))))
			 nfrag)
			(if (equal typ 'S)
			    (let ()
				 (setq *success-combine* nil)
				 frag2)
			    (let ()
				 (setq nfrag (make-frag typ 
					(cons 'name name1)
					(cons 'head (fragment-head frag2))
					(cons (fragment-fragtype frag1) frag1)
					(cons (fragment-fragtype frag2) frag2)))
				 nfrag)))
		   )) )
	)
  )

(defun try-relc-combine (frag1 frag2)
  ; want to put frag1 into frag2 if possible
  (setq *success-combine* t)
  (cond ((and (equal (fragment-fragtype frag2) 'NP)
	      (or (not (fragment-negated frag2) )
		  (not (equal (fragment-fragtype frag1) 'NP))))
	 (let* ((nv (make-into-VP frag1))
	       (nfrag (VP-into-RelC nv)))
	       (conjunct-prop frag2 'RELC (fragment-relc nfrag))
	       frag2
	       ))
	(t (let* ((nv (make-into-VP frag2))
	       (nfrag (VP-into-RelC nv)))
	       (conjunct-prop frag1 'RELC (fragment-relc nfrag))
	       frag1
	      ))
	)
  )

(defun conjunct-prop (frag prop value &aux nval )
  (if (setq nval (getp frag prop))
  (cond ((member prop *fragment-types*)
	 ; must combine the two fragments into a conjunction
	 (setp frag prop (make-conj nil 'and (list (getp frag prop) value)
				    (getp frag 'name) frag))
		   )
	((member prop *fragment-groups*)
	 (dolist (v (if (listp value) value (list value))) (setp v 'head frag))
	 (setp frag prop (append (getp frag prop) value))
	 )
	((member prop *multiple-fields*)
	 (setp frag prop (if (listp value) (if (listp nval)
			       (append value nval) (append value (list nval)))
			(if (listp nval) 
			    (append (list value) nval) (list value nval)))))
	((and (equal prop 'noun) (member nval *basic-nouns*))
	 (setp frag prop value))
	(t nil) ; leave as is
	)
      (progn 
      (setp frag prop value)
      (if (member prop *fragment-types*)
	  (setp value 'head frag)
	  (if (member prop *fragment-groups*)
	      (mapcar #'(lambda (a) (setp a 'head frag)) value)))
       ))
  frag)

(defun basic-item (item &aux ftype)
  (cond ((null item) nil)
	((not (symbolp item)) nil)
	((member (setq ftype (getp item 'frag-type)) '(NP S))
	 (case ftype
	       (S (fragment-VP item))
	       (NP (or (fragment-noun item)
		       (fragment-pronoun item)
		       (fragment-proper-noun item)))
	       ))
	)
  )

(defun basic (item)
  (cond ((null item) nil)
	((not (symbolp item)) nil)
	(t (case (getp item 'frag-type)
		 (S (fragment-VP item))
		 (NP (or (fragment-noun item)
			 (fragment-pronoun item)
			 (fragment-proper-noun item)))
		 (VP (fragment-verb item))
		 ))
	)
  )

(defun not-combinable (item1 item2 &aux n1 n2
			     (ftype1 (fragment-fragtype item1))
			     (ftype2 (fragment-fragtype item2)))
  (or (and (not (equal (fragment-negated item1) (fragment-negated item2)))
	   (or (if (fragment-ap item1) 
			 (if (setq n1 (fragment-noun item1))
			     (not (member n1 *basic-nouns*))
			     t))
		     (fragment-pp item1)
	       (fragment-relc item1) (fragment-vp item1))
	   (or (if (fragment-ap item2) 
			 (if (setq n2 (fragment-noun item2))
			     (not (member n2 *basic-nouns*))
			     t))
		     (fragment-pp item2)
	       (fragment-relc item2) (fragment-vp item2))
	   )
      (or (equal ftype1 'VP) (equal ftype2 'VP))
      (case ftype1 
	(NP (if (and (setq n1 (fragment-noun item1)) 
		     (setq n2 (fragment-noun item2)))
		(if (not (equal n1 n2))
		    (if (or (member n1 *basic-nouns*) (member n2 *basic-nouns*))
			nil
			t)
		    (if (member n1 *basic-nouns*)
			nil
			(not (equal (fragment-negated item1) (fragment-negated item2))))))
	 )
	(S (or (and (fragment-NP item1) (fragment-NP item2))
	       (and (fragment-VP item1) (fragment-VP item2))))
	(VP t)
	)
      )
  )

(defun disjunct-frags (&rest lists)
  (when (traced-p 'combine)
	(print-line "Response: need to combine disjunctively: ")
	(mapcar 'print-frag lists) )
  lists)

