;       Last change    August 1993
(in-package user)
(eval-when (compile load eval)   
(provide 'epilog)
(require 'lib "epilog:lib;lib")
(require 'epilib "epilog:epilib;epilib")
(require 'specialist-interface 
  "epilog:spec;spec")
(require 'response-pkg  
  "epilog:response;response")
(require 'eshell "epilog:eshell;eshell")
(defpackage epilog (:nicknames epi) 
  (:use user lisp #+lucid lucid-common-lisp #-lucid common-lisp #+excl excl lib epilib 
	      eshell response-pkg specialist-interface)
  (:export

	  ;  User interface routines
	  traceable traced-p trace-item untrace-item trace-all untrace-all
	  print-traceables
	  tweakable tweak print-tweakables
	  add-hier add-indicate add-topic hier-type add-part-hier
	  knowledge kn goal-knowledge goal-kn mp meaning-postulate gkn
	  simplification-schema simp-schema ss
	  story meta q question proof-q disproof-q help pq dq
	  display print-display instance-type content description prob
	  retrieve ret get-everything 
	  checkpoint-question rewind-question
	  set-specialist use-spec define-specialist function-with-rel-pred
	  say-it say-them add-word add-lex
	  esh esh-add-command add-for-tracing
	   
	  ;; Top level esh functions
	  epi-shell esh-version esh-add-cmds
	  ;; Eshell Global variables
	  *esh-command-list* *esh-help-path*
	  *esh-trace-output* *esh-filename-case*
	  *esh-error-prefix*
	  ))
(unless (find-package 'epilog) (make-package 'epilog)))
(in-package epilog)

(setq *help-path* "epilog:help;.hlp")

(load "epilog:story;eval")
(load "epilog:story;forward")
(load "epilog:story;qa")
(load "epilog:story;enter")
(load "epilog:story;subgoal")
(load "epilog:story;access")
(load "epilog:story;user")
